// @addtogroup rounding
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file ibm.h
///
/// @author CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.


#define ROUND_MASK    NOT 0C00h
#define ROUND_NEAREST 0
#define ROUND_DOWN    1 SHL 10
#define ROUND_UP      2 SHL 10
#define ROUND_CUT     3 SHL 10
#define IM_SET        0001h
#define IM_CLEAR      NOT 0001h

namespace capd{
namespace rounding{

inline void DoubleRounding::roundNearest()
{
  unsigned short fpu_nearest_cw;
  asm              fstcw  fpu_nearest_cw;
  asm              and    fpu_nearest_cw, ROUND_MASK;
  asm              or     fpu_nearest_cw, ROUND_NEAREST;
  asm              fldcw  fpu_nearest_cw;
}

inline void DoubleRounding::roundUp()
{
  unsigned short fpu_up_cw;
  asm              fstcw  fpu_up_cw;
  asm              and    fpu_up_cw, ROUND_MASK;
  asm              or     fpu_up_cw, ROUND_UP;
  asm              fldcw  fpu_up_cw;
}

inline void DoubleRounding::roundDown()
{
  unsigned short fpu_down_cw;
  asm              fstcw  fpu_down_cw;
  asm              and    fpu_down_cw, ROUND_MASK;
  asm              or     fpu_down_cw, ROUND_DOWN;
  asm              fldcw  fpu_down_cw;
}

inline void DoubleRounding::roundCut()
{
  unsigned short fpu_cut_cw;
  asm              fstcw  fpu_cut_cw;
  asm              and    fpu_cut_cw, ROUND_MASK;
  asm              or     fpu_cut_cw, ROUND_CUT;
  asm              fldcw  fpu_cut_cw;
}

inline void set_intel_im(void)
{
  unsigned short fpu_cut_cw;
  asm              fstcw  fpu_cut_cw;
  asm              or     fpu_cut_cw, IM_SET;
  asm              fldcw  fpu_cut_cw;
}

inline void clear_intel_im(void)
{
  unsigned short fpu_cut_cw;
  asm              fstcw  fpu_cut_cw;
  asm              and    fpu_cut_cw, IM_CLEAR;
  asm              fldcw  fpu_cut_cw;
}

}} // namespace capd::rounding

/// @}
